unit U_turtle;

interface

uses ExtCtrls, Graphics;

type
     TTurtle= class
                private
                z: TPaintBox;
                PosX, PosY: real;
                Dir: real;
                Pen: boolean;
                public
                constructor Create(pb: TPaintBox); { Initialisiert die Turtle mit der zugehrigen Zeichenflche }
                procedure SH;                      { Stift hoch }
                procedure SA;                      { Stift ab }
                procedure DL(d: real);             { Drehe links }
                procedure DR(d: real);             { Drehe rechts }
                procedure VW(d: real);             { Vorwrts }
                procedure RW(d: real);             { Rckwrts }
                procedure Setze(x, y, d: integer); { Turtle auf eine Position setzen }
                procedure Mitte;                   { Turtle in die Mitte setzen }
                procedure Links;                   { Turtle mittig an den linken Bildschirmrand setzen }
                procedure Rechts;                  { Turtle mittig an den rechten Bildschirmrand setzen }
                procedure Oben;                    { Turtle mittig an den oberen Bildschirmrand setzen }
                procedure Unten;                   { Turtle mittig an den unteren Bildschirmrand setzen }
             end;

implementation

{ --------------------- mathematische Hilfsfunktionen --------------------------- }
function arcsin(x: real): real;
begin
  arcsin:= arctan(x/sqrt(1-sqr(x)))
end;

function arccos(x: real): real;
begin
  arccos:= arctan(sqrt(1-sqr(x))/x);
end;

{ --------------------- Turtle-Methoden --------------------------- }

procedure TTurtle.Mitte;
begin
  PosX:= z.Width div 2;
  PosY:= z.Height div 2;
  Dir:= 90;
end;

procedure TTurtle.Links;
begin
  PosX:= 0;
  PosY:= z.Height div 2;
  Dir:= 0;
end;

procedure TTurtle.Rechts;
begin
  PosX:= z.Width;
  PosY:= z.Height div 2;
  Dir:= 180;
end;

procedure TTurtle.Oben;
begin
  PosX:= z.Width div 2;
  PosY:= 0;
  Dir:= 270;
end;

procedure TTurtle.Unten;
begin
  PosX:= z.Width div 2;
  PosY:= z.Height;
  Dir:= 90;
end;

Constructor TTurtle.Create(pb: TPaintBox);
begin
  z:= pb;
  PosX:= 0;
  PosY:= 0;
  Dir:= 0;
  Pen:= true;
  Mitte;
  z.Refresh;
end;

procedure TTurtle.SH;
begin
  Pen:= false;
end;

procedure TTurtle.SA;
begin
  Pen:= true;
end;

procedure TTurtle.DL(d: real);
begin
  Dir:= Dir+d;
  if Dir>360 then while Dir>360 do Dir:= Dir-360
             else while Dir<0 do Dir:= Dir+360;
end;

procedure TTurtle.DR(d: real);
begin
  DL(-d);
end;

procedure TTurtle.VW(d: real);
begin
  z.Canvas.MoveTo(trunc(PosX),trunc(PosY));
  PosX:= PosX+cos(Dir/180*pi)*d;
  PosY:= PosY-sin(Dir/180*pi)*d;
  if Pen then
    z.Canvas.LineTo(trunc(PosX),trunc(PosY));
end;

procedure TTurtle.RW(d: real);
begin
  VW(-d);
end;

procedure TTurtle.Setze(x, y, d: integer);
begin
  PosX:= x;
  PosY:= y;
  Dir:= d;
end;

end.
